# datepicker-dayjs 

[![npm](https://img.shields.io/npm/v/datepicker-dayjs.svg)](https://www.npmjs.com/package/datepicker-dayjs)
[![styled with prettier](https://img.shields.io/badge/styled_with-prettier-ff69b4.svg)](https://github.com/prettier/prettier)

React datetime picker powered by [dayjs](https://github.com/iamkun/dayjs)

Forked from [input-dayjs](https://www.npmjs.com/package/input-dayjs)

The design is from https://dribbble.com/shots/1439965-Due-Date-and-Time-Picker.

The icon is from [ionicons](http://ionicons.com/).

### Installation

```sh
yarn add datepicker-dayjs
```

**Notice:** This module requires [dayjs](https://www.npmjs.com/package/dayjs) as a [peerDependency](https://docs.npmjs.com/files/package.json#peerdependencies).

### What's new

- **Date range picker**.
- Customizable labels.
- Time can be changed by keyboard also.

### Usage

```javascript

import { InputDateRange } from 'datepicker-dayjs';
import 'datepicker-dayjs/dist/input-dayjs.css'


<InputDateRange
  onChangeFirstDate={(daysjsObj) => {
    console.log(daysjsObj.hour());
  }}
  onChangeEndDate={(daysjsObj) => {
    console.log(daysjsObj.hour());
  }}
  dateLabel="Fecha"
  timeLabel="Horario"
  hourLabel="Hora"
  minuteLabel="Minutos"
  saveLabel="Aplicar"
  minStep={1} // default
  hourStep={1} // default
  prevMonthIcon="ion-ios-arrow-left" // default
  nextMonthIcon="ion-ios-arrow-right" // default
>
  {(startDayjs, endDatejs, handleStartDateClick, handleEndDateClick) => (
    <div className="input__container">
      <label>Start</label>
      <input
        onClick={handleStartDateClick}
        type="text"
        value={startDayjs.format("DD/MM/YYYY HH:mm")}
        readOnly
      />
      <label>End</label>
      <input
        onClick={handleEndDateClick}
        type="text"
        value={endDatejs.format("DD/MM/YYYY HH:mm")}
        readOnly
      />
    </div>
  )}
</InputDateRange>
```

### Development
- npm install
- npm start
- http://localhost:8080

### License
ISC
