"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _range = _interopRequireDefault(require("lodash/range"));

var _chunk = _interopRequireDefault(require("lodash/chunk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const Day = ({
  i,
  w,
  d,
  className,
  ...props
}) => {
  const prevMonth = w === 0 && i > 7;
  const nextMonth = w >= 4 && i <= 14;
  const cls = (0, _classnames.default)({
    'prev-month': prevMonth,
    'next-month': nextMonth,
    'current-day': !prevMonth && !nextMonth && i === d
  });
  return /*#__PURE__*/_react.default.createElement("td", _extends({
    className: cls
  }, props), i);
};

const Calendar = ({
  onChange,
  dayjs,
  className,
  prevMonthIcon,
  nextMonthIcon
}) => {
  const selectDate = (i, w) => {
    const prevMonth = w === 0 && i > 7;
    const nextMonth = w >= 4 && i <= 14;
    let d = dayjs;
    if (prevMonth) d = d.subtract(1, 'month');
    if (nextMonth) d = d.add(1, 'month');
    d = d.set('date', i);
    onChange(d);
  };

  const prevMonth = e => {
    e.preventDefault();
    onChange(dayjs.subtract(1, 'month'));
  };

  const nextMonth = e => {
    e.preventDefault();
    onChange(dayjs.add(1, 'month'));
  };

  const m = dayjs;
  const d = m.date();
  const d1 = m.clone().subtract(1, 'month').endOf('month').date();
  const d2 = m.clone().set('date', 1).day();
  const d3 = m.clone().endOf('month').date();
  const days = [].concat((0, _range.default)(d1 - d2 + 1, d1 + 1), (0, _range.default)(1, d3 + 1), (0, _range.default)(1, 42 - d3 - d2 + 1));
  const weeks = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)('m-calendar', className)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "toolbar"
  }, /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    className: "prev-month",
    onClick: prevMonth
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: prevMonthIcon
  })), /*#__PURE__*/_react.default.createElement("span", {
    className: "current-date"
  }, m.format('MMMM YYYY')), /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    className: "next-month",
    onClick: nextMonth
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: nextMonthIcon
  }))), /*#__PURE__*/_react.default.createElement("table", null, /*#__PURE__*/_react.default.createElement("thead", null, /*#__PURE__*/_react.default.createElement("tr", null, weeks.map((w, i) => /*#__PURE__*/_react.default.createElement("td", {
    key: i
  }, w)))), /*#__PURE__*/_react.default.createElement("tbody", null, (0, _chunk.default)(days, 7).map((row, w) => /*#__PURE__*/_react.default.createElement("tr", {
    key: w
  }, row.map(i => /*#__PURE__*/_react.default.createElement(Day, {
    key: i,
    i: i,
    d: d,
    w: w,
    onClick: () => selectDate(i, w)
  })))))));
};

var _default = Calendar;
exports.default = _default;