"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _dayjs = _interopRequireDefault(require("dayjs"));

var _inputDayjs = _interopRequireDefault(require("./input-dayjs"));

var _bind = _interopRequireDefault(require("classnames/bind"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const InputDateRange = ({
  minStep,
  containerClassName,
  dateLabel,
  timeLabel,
  hourLabel,
  minuteLabel,
  saveLabel,
  onChangeFirstDate,
  onChangeEndDate,
  defaultStartDate,
  defaultEndDate,
  children
}) => {
  const [showStartDateWidget, setShowStartDateWidget] = (0, _react.useState)(false);
  const [showEndDateWidget, setShowEndDateWidget] = (0, _react.useState)(false);
  const [dayjsStartDate, setDayjsStartDate] = (0, _react.useState)((0, _dayjs.default)(defaultStartDate) || (0, _dayjs.default)().subtract(1, 'week'));
  const [dayjsEndDate, setDayjsEndDate] = (0, _react.useState)((0, _dayjs.default)(defaultEndDate) || (0, _dayjs.default)());
  const containerClass = (0, _bind.default)({
    [containerClassName]: true,
    widget__container: true,
    'widget__container--first': showStartDateWidget,
    'widget__container--second': showEndDateWidget
  });

  const handleChangeStartDate = d => setDayjsStartDate(d);

  const handleChangeEndDate = d => setDayjsEndDate(d);

  const handleStartDateClick = () => {
    setShowStartDateWidget(!showStartDateWidget);
    setShowEndDateWidget(false);
  };

  const handleEndDateClick = () => {
    setShowEndDateWidget(!showEndDateWidget);
    setShowStartDateWidget(false);
  };

  const handleOnSaveStartDate = () => {
    onChangeFirstDate(dayjsStartDate);
    setShowEndDateWidget(true);
    setShowStartDateWidget(false);
  };

  const handleOnSaveEndDate = () => {
    onChangeEndDate(dayjsEndDate);
    setShowEndDateWidget(false);
    setShowStartDateWidget(false);
  };

  return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, children(dayjsStartDate, dayjsEndDate, handleStartDateClick, handleEndDateClick), /*#__PURE__*/_react.default.createElement("div", {
    className: containerClass
  }, /*#__PURE__*/_react.default.createElement(_inputDayjs.default, {
    dateLabel: dateLabel,
    timeLabel: timeLabel,
    hourLabel: hourLabel,
    minuteLabel: minuteLabel,
    saveLabel: saveLabel,
    dayjs: dayjsStartDate,
    onChange: handleChangeStartDate,
    onSave: handleOnSaveStartDate,
    minStep: minStep
  }), /*#__PURE__*/_react.default.createElement(_inputDayjs.default, {
    dateLabel: dateLabel,
    timeLabel: timeLabel,
    hourLabel: hourLabel,
    minuteLabel: minuteLabel,
    saveLabel: saveLabel,
    dayjs: dayjsEndDate,
    onChange: handleChangeEndDate,
    onSave: handleOnSaveEndDate,
    minStep: minStep
  })));
};

var _default = InputDateRange;
exports.default = _default;