"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _calendar = _interopRequireDefault(require("./calendar"));

var _time = _interopRequireDefault(require("./time"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const InputDayJS = ({
  onSave,
  onChange,
  className,
  prevMonthIcon,
  nextMonthIcon,
  minStep,
  hourStep,
  dayjs: d,
  dateLabel,
  timeLabel,
  hourLabel,
  minuteLabel,
  saveLabel
}) => {
  const [tab, setTab] = (0, _react.useState)(0);

  const handleClickTab = (e, tab) => {
    e.preventDefault();
    setTab(tab);
  };

  const handleSave = e => {
    e.preventDefault();
    if (onSave) onSave();
  };

  const cls = (0, _classnames.default)('m-input-dayjs', className);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: cls
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "options"
  }, /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    className: (0, _classnames.default)('ion-calendar im-btn', {
      'is-active': tab === 0
    }),
    onClick: e => handleClickTab(e, 0)
  }, dateLabel || 'Date'), /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    className: (0, _classnames.default)('ion-clock im-btn', {
      'is-active': tab === 1
    }),
    onClick: e => handleClickTab(e, 1)
  }, timeLabel || 'Time')), /*#__PURE__*/_react.default.createElement("div", {
    className: "tabs"
  }, /*#__PURE__*/_react.default.createElement(_calendar.default, {
    className: (0, _classnames.default)('tab', {
      'is-active': tab === 0
    }),
    dayjs: d,
    onChange: onChange,
    prevMonthIcon: prevMonthIcon || 'ion-ios-arrow-left',
    nextMonthIcon: nextMonthIcon || 'ion-ios-arrow-right'
  }), /*#__PURE__*/_react.default.createElement(_time.default, {
    className: (0, _classnames.default)('tab', {
      'is-active': tab === 1
    }),
    dayjs: d,
    minStep: minStep || 1,
    hourStep: hourStep || 1,
    onChange: onChange,
    hourLabel: hourLabel,
    minuteLabel: minuteLabel
  })), onSave ? /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    className: "im-btn btn-save ion-checkmark",
    onClick: handleSave
  }, saveLabel || 'Save') : null);
};

var _default = InputDayJS;
exports.default = _default;