"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireWildcard(require("react"));

var _reactInputSlider = _interopRequireDefault(require("react-input-slider"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Time = ({
  dayjs,
  onChange,
  className,
  hourStep,
  minStep,
  hourLabel,
  minuteLabel
}) => {
  const changeHours = pos => {
    const newTime = dayjs;
    const d = newTime.set('hour', pos.x);
    onChange(d);
  };

  const changeMinutes = pos => {
    const newTime = dayjs;
    const d = newTime.set('minutes', pos.x);
    return onChange(d);
  };

  const handleInputHourChange = e => {
    e.preventDefault();
    const newTime = dayjs;
    const value = e.target.value;
    const d = newTime.set('hour', value);
    onChange(d);
    e.stopPropagation();
  };

  const handleInputMinuteChange = e => {
    e.preventDefault();
    const newTime = dayjs;
    const value = e.target.value;
    const d = newTime.set('minute', value);
    onChange(d);
    e.stopPropagation();
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)('m-time', className)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "showtime"
  }, /*#__PURE__*/_react.default.createElement("input", {
    name: "time-input",
    className: "time",
    value: dayjs.format('HH'),
    onChange: handleInputHourChange
  }), /*#__PURE__*/_react.default.createElement("span", {
    className: "separater"
  }, ":"), /*#__PURE__*/_react.default.createElement("input", {
    name: "time-input",
    className: "time",
    value: dayjs.format('mm'),
    onChange: handleInputMinuteChange
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "sliders"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "time-text"
  }, hourLabel || 'Hours', ":"), /*#__PURE__*/_react.default.createElement(_reactInputSlider.default, {
    className: "u-slider-time",
    xmin: 0,
    xmax: 23,
    xstep: hourStep,
    x: dayjs.hour(),
    onChange: changeHours
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "time-text"
  }, minuteLabel || 'Minutes', ":"), /*#__PURE__*/_react.default.createElement(_reactInputSlider.default, {
    className: "u-slider-time",
    xmin: 0,
    xmax: 59,
    xstep: minStep,
    x: dayjs.minute(),
    onChange: changeMinutes
  })));
};

var _default = Time;
exports.default = _default;